#pragma once
#include "ComponentUI.h"
#include "NPCommonUI.h"

//////////////////////////////////////////////////////////////////////////

class CAbstractButton;
/**
* @ingroup 	Base UI	
* @brief 	Button UI Interface
* @date		10/25/2006
* @author	telltale
* @remark	
*/
interface NPCOMMONUI_API IButtonUI : public IComponentUI
{
	DECLARE_RTTI;

public:
	virtual ~IButtonUI() {  }
	/**
	* @brief 	method which renders background of the current button
	* @param	hDC		handle to device context 
	* @param	pButton	current button to render
	* @return	none
	*/
	virtual void	DrawBackground(HDC hDC, CAbstractButton* pButton) = 0;
	/**
	* @brief 	method which renders the text of the current button
	* @param	hDC		handle to device context 
	* @param	pButton	current button to render
	* @param	lpRect	bounding rectangle to render the text
	* @param	pszcText	string to render
	* @return	none
	*/
	virtual void	DrawText(HDC hDC, CAbstractButton* pButton, LPRECT lpRect, LPCTSTR pszcText) = 0;
};

//////////////////////////////////////////////////////////////////////////

interface IButtonStateChangeDelegate
{
public:
	virtual ~IButtonStateChangeDelegate() {}

	virtual BOOL IsChangingAvailable(CAbstractButton* pBtn) = 0;
};

//////////////////////////////////////////////////////////////////////////

class CButtonStateCgDg_Def : public IButtonStateChangeDelegate
{
public:
	CButtonStateCgDg_Def() {}
	virtual ~CButtonStateCgDg_Def() {}

	//override
	//IButtonStateChangeDelegate
	BOOL IsChangingAvailable(CAbstractButton* pBtn) { return TRUE; }
protected:
private:
};